## bornagain 1.18.0

=== CMakeLists.txt ===
###########################################################################
# top-level CMakeLists.txt for building BornAgain
############################################################################

cmake_minimum_required(VERSION 3.14 FATAL_ERROR)

set(CMAKE_MODULE_PATH
    ${CMAKE_SOURCE_DIR}/cmake
    ${CMAKE_SOURCE_DIR}/cmake/find
    ${CMAKE_SOURCE_DIR}/cmake/pack)
set(CONFIGURABLES_DIR ${CMAKE_SOURCE_DIR}/cmake/configurables)

include(commons/PreventInSourceBuilds)

project(BornAgain
    VERSION 1.18.0
    DESCRIPTION "BornAgain: simulate and fit scattering at grazing incidence."
    HOMEPAGE_URL https://www.bornagainproject.org
    ) # LANGUAGES CXX)
     # TODO modernize FindCerf to get rid of AssertLibraryFunction to restore restriction to CXX

set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 17)

include(CTest) # equivalent to "enable_testing() ???
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} -LE Fullcheck)
   # => 'make check' is an alias for 'ctest'
add_custom_target(fullcheck COMMAND ${CMAKE_CTEST_COMMAND})
   # => 'make check' is an alias for 'ctest'

## Project-wide user flags

# options that are on by default (switch off for accelerated builds of limited scope)
option(BORNAGAIN_PYTHON "Build with python support" ON)
option(BORNAGAIN_GUI "Build a graphical user interface" ON)
option(BORNAGAIN_TIFF_SUPPORT "Tiff files read/write support" ON)

# options that are off by default (switch on for additional functionality)
option(BORNAGAIN_MPI "Build with MPI support" OFF)
option(SLOWTESTS "CTest also covers slow tests" OFF)

option(CONFIGURE_BINDINGS "Generate python bindings during build (requires swig)" OFF)
option(CONFIGURE_PYTHON_DOCS "Generate python documentation from the doxygen comments" OFF)
option(CONFIGURE_MANPAGE "Build Unix man page" OFF)
option(CONFIGURE_DOXY "Configure Doxygen files" OFF)
option(ALLCONFIG "Regenerate Py docs, Py wrappers, man page, Doxyfiles" OFF)

option(BUILD_DEBIAN "Build a debian package" OFF)
option(BORNAGAIN_APPLE_BUNDLE "Create a Mac OS X bundle" OFF)

option(ZERO_TOLERANCE "Terminate compilation on warnings" OFF)
option(BORNAGAIN_COVERAGE "Build with test coverage information" OFF)
option(BORNAGAIN_DEBUG_OPTIMIZATION "Build with debug optimization (gcc only)" OFF)
option(BORNAGAIN_TIDY "Invokes clang-tidy" OFF)

if(BORNAGAIN_TIDY AND BORNAGAIN_PYTHON)
    message(FATAL_ERROR "BORNAGAIN_TIDY is incompatible with BORNAGAIN_PYTHON")
endif()

if(BORNAGAIN_GUI AND NOT BORNAGAIN_PYTHON AND NOT BORNAGAIN_TIDY)
    message(FATAL_ERROR "BORNAGAIN_GUI without BORNAGAIN_PYTHON is currently unsupported"
        " (except with BORNAGAIN_TIDY)")
endif()

if(ALLCONFIG)
    set(CONFIGURE_MANPAGE ON)
    set(CONFIGURE_PYTHON_DOCS ON)
    set(CONFIGURE_BINDINGS ON)
    set(CONFIGURE_DOXY ON)
endif()

## Various CMake settings (include order is of critical importance)

# function definitions
include(commons/GetFilenameComponent) # overwrite CMake command
include(BornAgain/MakeLib)
include(BornAgain/SwigLib)

# main settings

include(BornAgain/Directories)

if(CMAKE_SYSTEM_NAME MATCHES Linux)
    include(BornAgain/Linux)
    include(BornAgain/NixInstall)
elseif(APPLE)
    include(BornAgain/MacOS)
    include(BornAgain/NixInstall)
elseif(WIN32)
    include(BornAgain/Windows)
endif()

include(BornAgain/Compiler)
if(ZERO_TOLERANCE)
    string(APPEND CMAKE_CXX_FLAGS " -Werror -Wfatal-errors")
endif()

include(BornAgain/Dependences)
if(BORNAGAIN_GUI)
    include(BornAgain/Qt)
    string(APPEND CMAKE_CXX_FLAGS " -DHAVE_QT=ON")
endif()
include(BornAgain/Config)
if(BORNAGAIN_PYTHON)
    include(BornAgain/PythonAPI)
endif()
include(BornAgain/PythonDocs)

# debug optimization
if(BORNAGAIN_DEBUG_OPTIMIZATION)
  include(commons/DebugOptimization)
endif()

## recurse into the given subdirectories

# BornAgain components are build as separate shared libraries
set(CoreComponents "Base;Fit;Param;Sample;Device;Core")
set(AllComponents "${CoreComponents};GUI")

# code analysis
include(BornAgain/LineLength)
if(BORNAGAIN_COVERAGE)
  include(commons/CoverageFunction)
  include(BornAgain/Coverage)
endif()

# third-party code
add_subdirectory(ThirdParty/common)
add_subdirectory(ThirdParty/Fit)
add_subdirectory(ThirdParty/Core)
if(BORNAGAIN_GUI)
    add_subdirectory(ThirdParty/GUI)
endif()

# from here on our own code, occasionally scrutinized by clang-tidy
if(BORNAGAIN_TIDY)
    set(CMAKE_CXX_CLANG_TIDY "clang-tidy") # has effect only if compiler is clang; uses .clang-tidy
endif()

# core components
foreach(lib ${CoreComponents})
    add_subdirectory(${lib})
endforeach()
if(BORNAGAIN_PYTHON)
    add_dependencies(BornAgainFit swig_runtime)
endif()

# core tests
add_subdirectory(Tests/UnitTests/Fit)
add_subdirectory(Tests/UnitTests/Core)
add_subdirectory(Tests/UnitTests/Numeric)
add_subdirectory(Tests/Performance/Core)

# GUI
if(BORNAGAIN_GUI)
    add_subdirectory(GUI)
    add_subdirectory(Tests/UnitTests/GUI)
    add_subdirectory(Tests/Performance/GUI)
endif()

# TODO: split Core / GUI
add_subdirectory(Tests/Functional)

# documentation
if(BORNAGAIN_USERMANUAL)
    add_subdirectory(Doc/UserManual)
endif()
if(CONFIGURE_MANPAGE)
    add_subdirectory(Doc/man)
endif()
if(CONFIGURE_DOXY)
    add_subdirectory(Doc/Doxygen)
endif()

# after-install message
add_subdirectory(cmake)

# make package targets
include(BornAgain/Pack)

message(STATUS "CMake done")

=== Base/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainCore
############################################################################

set(name Base)
set(lib BornAgain${name})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

MakeLib(${name} ${lib} ${CMAKE_CURRENT_BINARY_DIR}/Wrap)

set(${lib}_LIBRARY ${lib} PARENT_SCOPE)

# --- external dependencies ---

# target_link_libraries(${lib} ${CMAKE_THREAD_LIBS_INIT})

target_include_directories(${lib}
    PUBLIC ${CMAKE_SOURCE_DIR} ${GSL_INCLUDE_DIR} ${FFTW3_INCLUDE_DIR} ${Boost_INCLUDE_DIRS}
    SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIRS}
    )
target_link_libraries(${lib} ${GSL_LIBRARIES} ${FFTW3_LIBRARIES} ${Boost_LIBRARIES})

if(BORNAGAIN_MPI)
    add_definitions(-DBORNAGAIN_MPI)
    include_directories(${MPI_INCLUDE_PATH})
    target_link_libraries(${lib} ${MPI_LIBRARIES})
endif()

=== Fit/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainFit
############################################################################

set(name Fit)
set(lib BornAgain${name})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

MakeLib(${name} ${lib} ${CMAKE_CURRENT_BINARY_DIR}/Wrap)

set(${lib}_LIBRARY ${lib} PARENT_SCOPE)

# --- external dependencies ---

target_include_directories(${lib}
    PUBLIC ${RootMinimizers_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR})
target_link_libraries(${lib} ${RootMinimizers_LIBRARY} ${Boost_LIBRARIES})

=== GUI/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building BornAgain/GUI libraries and executable
############################################################################

message(STATUS "Configuring BornAgain GUI")

set(CMAKE_AUTOMOC ON)

add_subdirectory(ba3d)
add_subdirectory(coregui)
add_subdirectory(main)

set(BornAgainGUI_INCLUDE_DIRS ${BornAgainGUI_INCLUDE_DIRS} PARENT_SCOPE)
set(BornAgainGUI_LIBRARY ${BornAgainGUI_LIBRARY} PARENT_SCOPE)

set(ba3d_INCLUDE_DIRS ${ba3d_INCLUDE_DIRS} PARENT_SCOPE)
set(ba3d_LIBRARY ${ba3d_LIBRARY} PARENT_SCOPE)

=== Doc/Doxygen/CMakeLists.txt ===
# configure Doxyfiles; define targets doxy and doxy${flavor}
set(AUTO_DOX_DIR ${CMAKE_BINARY_DIR}/doxygen)
file(MAKE_DIRECTORY ${AUTO_DOX_DIR})
file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/html)
add_custom_target(doxy) # this target builds _all_ documentation flavors
foreach(flavor user long)
    configure_file(Doxyfile.${flavor}.in
        ${AUTO_DOX_DIR}/Doxyfile.${flavor} @ONLY)
    add_custom_target(doxy${flavor}
        COMMAND doxygen ${AUTO_DOX_DIR}/Doxyfile.${flavor} )
    add_dependencies(doxy doxy${flavor})
endforeach()

=== Doc/man/CMakeLists.txt ===
set(AUTO_DIR "${CMAKE_SOURCE_DIR}/auto/Doc/man")
file(MAKE_DIRECTORY ${AUTO_DIR})

add_custom_target(
    man ALL
    DEPENDS "${AUTO_DIR}/bornagain.1"
)

add_custom_command(
    OUTPUT "${AUTO_DIR}/bornagain.1"
    COMMAND ${POD2MAN} -s 1 -c "BornAgain manual" ${CMAKE_CURRENT_SOURCE_DIR}/bornagain.pod ${AUTO_DIR}/bornagain.1
    DEPENDS bornagain.pod
)

install(FILES ${AUTO_DIR}/bornagain.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/man/man1)

=== GUI/coregui/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainGUI library
############################################################################
set(library_name BornAgainGUI)

# --- source and include files ---
set(include_dirs
    ${CMAKE_CURRENT_SOURCE_DIR}/mainwindow
    ${CMAKE_CURRENT_SOURCE_DIR}/utils
    ${CMAKE_CURRENT_SOURCE_DIR}/Models
    ${CMAKE_CURRENT_SOURCE_DIR}/Views
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/SampleDesigner
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/JobWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/IntensityDataWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/InfoWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/MaterialEditor
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/InstrumentWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/SimulationWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/FitWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/PropertyEditor
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/MaskWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/AccordionWidget
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/ImportDataWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/ImportDataWidgets/CsvImportAssistant
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/CommonWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/RealSpaceWidgets
    ${CMAKE_CURRENT_SOURCE_DIR}/Views/SpecularDataWidgets
)


set(source_files)
set(include_files)

foreach(dir ${include_dirs})
    file(GLOB source ${dir}/*.cpp)
    file(GLOB include ${dir}/*.h)
    list(APPEND source_files ${source})
    list(APPEND include_files ${include})
endforeach()

set(source_widgetbox
    "Views/widgetbox/widgetboxcategorylistview.cpp"
    "Views/widgetbox/widgetboxtreewidget.cpp"
    "Views/widgetbox/widgetbox.cpp"
)
list(APPEND source_files ${source_widgetbox})

set(include_widgetbox
    "Views/widgetbox/widgetboxcategorylistview.h"
    "Views/widgetbox/widgetboxtreewidget.h"
    "Views/widgetbox/widgetbox.h"
    "Views/widgetbox/widgetbox_global.h"
)
if(WIN32)
    add_definitions(-DQDESIGNER_UILIB_LIBRARY)
endif()

list(APPEND include_files ${include_widgetbox})

list(APPEND include_dirs ${CMAKE_CURRENT_SOURCE_DIR}/Views/widgetbox)

set(resource_files
    "coregui.qrc"
    "Views/SampleDesigner/SampleDesigner.qrc"
    "Views/MaskWidgets/MaskWidgets.qrc"
    "Views/widgetbox/widgetbox.qrc"
    "Views/AccordionWidget/accordionwidgeticons.qrc"
)

# --- Qt configuration ---------
set(CMAKE_INCLUDE_CURRENT_DIR ON)
qt5_add_resources(RC_SRCS ${resource_files})

# --- definitions ------
if(BORNAGAIN_CRASHHANDLER)
    add_definitions(-DBORNAGAIN_CRASHHANDLER)
endif()

if(WIN32)
    string(APPEND CMAKE_CXX_FLAGS " -DBA_CORE_BUILD_DLL")
endif()


# --- making library ---------

add_library(${library_name} SHARED ${source_files} ${RC_SRCS} ${include_files})
set_target_properties(${library_name} PROPERTIES PREFIX ${libprefix} SUFFIX ${libsuffix})
set(${library_name}_LIBRARY_TYPE SHARED)
# exposing library name and list of include directories outside
set(${library_name}_INCLUDE_DIRS ${include_dirs} PARENT_SCOPE)
set(${library_name}_LIBRARY ${library_name} PARENT_SCOPE)


# --- dependencies ---------
target_include_directories(${library_name} PUBLIC ${QtAddOn_INCLUDE_DIRS} ${CMAKE_SOURCE_DIR})
target_include_directories(${library_name} PUBLIC ${include_dirs})
target_link_libraries(${library_name} ${QtAddOn_LIBRARIES} ${BornAgainCore_LIBRARY} ${ba3d_LIBRARY})
target_link_libraries(${library_name}
    Qt5::Widgets
    Qt5::Core
    Qt5::Gui
    Qt5::Designer
    Qt5::PrintSupport
    Qt5::Network
)

# --- Installation ---------
install (TARGETS ${library_name} DESTINATION ${destination_lib} COMPONENT Libraries)

if(WIN32)
    # --- Qt ---
    string(REGEX REPLACE "\\\\" "/" QTDIR $ENV{QTDIR} ) # Convert C:\Qt\ to C:/Qt/
    install(FILES
    ${QTDIR}/bin/Qt5Widgets.DLL
    ${QTDIR}/bin/Qt5Core.dll
    ${QTDIR}/bin/Qt5Gui.dll
    ${QTDIR}/bin/Qt5Designer.dll
    ${QTDIR}/bin/Qt5Xml.dll
    ${QTDIR}/bin/Qt5Svg.dll
    ${QTDIR}/bin/Qt5Network.dll
    ${QTDIR}/bin/Qt5PrintSupport.dll
    DESTINATION ${destination_lib} COMPONENT Libraries)

    install(FILES
    ${QTDIR}/plugins/platforms/qwindows.dll
    DESTINATION bin/platforms COMPONENT Libraries)

    install(FILES
    ${QTDIR}/plugins/iconengines/qsvgicon.dll
    DESTINATION bin/iconengines COMPONENT Libraries)

    install(FILES
    ${QTDIR}/plugins/imageformats/qjpeg.dll
    ${QTDIR}/plugins/imageformats/qsvg.dll
    DESTINATION bin/imageformats COMPONENT Libraries)

    install(FILES
    ${QTDIR}/bin/libEGL.dll
    ${QTDIR}/bin/libGLESv2.dll
    DESTINATION ${destination_lib} COMPONENT Libraries)

    set(QT_VISTA_STYLE "${QTDIR}/plugins/styles/qwindowsvistastyle.dll")
    if(EXISTS "${QT_VISTA_STYLE}")
        install(FILES ${QT_VISTA_STYLE}
                DESTINATION bin/styles COMPONENT Libraries)
    else(EXISTS "${QT_VISTA_STYLE}")
        MESSAGE(AUTHOR_WARNING "File ${QT_VISTA_STYLE} not found.")
    endif(EXISTS "${QT_VISTA_STYLE}")
    unset(QT_VISTA_STYLE)

endif()

=== GUI/main/CMakeLists.txt ===
###############################################################################
# Builds BornAgain/GUI main executable
###############################################################################
set(executable_name BornAgain)

set(source_files main.cpp appoptions.cpp MessageHandler.cpp)
set(include_files appoptions.h MessageHandler.h )

# -----------------------------------------------------------------------------
# Qt configuration
# -----------------------------------------------------------------------------
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)

# -----------------------------------------------------------------------------
# executable icons
# -----------------------------------------------------------------------------
if(WIN32)
    set(system_addons bornagain.rc)
    if(NOT win32_console)
        set(executable_options WIN32)
    endif()
endif()

if(APPLE)
    set(MACOSX_BUNDLE_ICON_FILE BornAgain.icns)
    set_source_files_properties(${CMAKE_SOURCE_DIR}/GUI/main/BornAgain.icns
        PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    if(BORNAGAIN_APPLE_BUNDLE)
        set(executable_options MACOSX_BUNDLE)
    endif()
endif()


# -----------------------------------------------------------------------------
# executable
# -----------------------------------------------------------------------------
add_executable(${executable_name}
               ${executable_options}
               ${source_files}
               ${system_addons})


# -----------------------------------------------------------------------------
# dependencies
# -----------------------------------------------------------------------------
target_link_libraries(${executable_name} ${BornAgainGUI_LIBRARY})


# -----------------------------------------------------------------------------
# extra target properties
# -----------------------------------------------------------------------------
if(WIN32)
    set_target_properties( ${executable_name} PROPERTIES LINK_FLAGS "/ENTRY:mainCRTStartup" )
    if(win32_console)
        set_target_properties( ${executable_name} PROPERTIES COMPILE_DEFINITIONS "_CONSOLE" )
    endif()
endif()

if(APPLE)
    set(MACOSX_BUNDLE_IDENTIFIER "org.bornagainproject.BornAgain")
    configure_file("${CONFIGURABLES_DIR}/MacOSXBundleInfo.plist.in"
        "${BUILD_VAR_DIR}/Info.plist" @ONLY)

    set_target_properties(${executable_name}
        PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${BUILD_VAR_DIR}/Info.plist)

    if(BORNAGAIN_APPLE_BUNDLE)
        # this makes sense only if we build a bundle
        set(link_flags "-Wl,-rpath,@loader_path/../Frameworks/ \
  -Wl,-rpath,@loader_path/../lib/BornAgain-${BornAgain_VERSION_MAJOR}.${BornAgain_VERSION_MINOR}/")
    else()
        set(link_flags "-Wl,-rpath,\
@loader_path/../../../lib/BornAgain-${BornAgain_VERSION_MAJOR}.${BornAgain_VERSION_MINOR}/")
    endif()
    set_target_properties(${executable_name} PROPERTIES LINK_FLAGS ${link_flags})
endif()


# -----------------------------------------------------------------------------
# installation section
# -----------------------------------------------------------------------------
if(BORNAGAIN_APPLE_BUNDLE)
    set(executable_destination BUNDLE DESTINATION  ".")
elseif(WIN32)
    set(executable_destination DESTINATION ${destination_gui})
else()
    set(executable_destination DESTINATION "${destination_gui}/exec")
endif()
#message(STATUS "Executable destination is ${executable_destination}")
install (TARGETS ${executable_name} ${executable_destination} COMPONENT Applications)

set(image_files
    ${CMAKE_SOURCE_DIR}/GUI/main/BornAgain.ico
    ${CMAKE_SOURCE_DIR}/GUI/main/BornAgain.icns
    ${CMAKE_SOURCE_DIR}/GUI/coregui/images/BornAgain_48x48.png
    ${CMAKE_SOURCE_DIR}/GUI/coregui/images/BornAgain_64x64.png)
install (FILES ${image_files} DESTINATION ${destination_images} COMPONENT Applications)


# -----------------------------------------------------------------------------
# system dependent installation
# -----------------------------------------------------------------------------
if(UNIX)
    if(BORNAGAIN_APPLE_BUNDLE)
        install( FILES ${CMAKE_SOURCE_DIR}/GUI/main/BornAgain.icns
            DESTINATION ${destination_bundle}/Contents/Resources/
        )
        install( FILES ${CMAKE_SOURCE_DIR}/cmake/configurables/qt.conf
            DESTINATION ${destination_bundle}/Contents/Resources/
        )
        configure_file(${CMAKE_SOURCE_DIR}/cmake/configurables/FixAppleBundle.cmake.in
                       ${BUILD_VAR_DIR}/FixAppleBundle.cmake @ONLY)
        install(SCRIPT ${BUILD_VAR_DIR}/FixAppleBundle.cmake COMPONENT Runtime)
    elseif(WIN32)
    elseif(NOT BUILD_DEBIAN)
        # creating link to BornAgain gui in bin directory
        install(CODE "
        execute_process(COMMAND \${CMAKE_COMMAND} -E create_symlink
        \"../${destination_libexec}/exec/BornAgain\" \"bornagain\"
        WORKING_DIRECTORY \"${CMAKE_INSTALL_PREFIX}/${destination_bin}\")
        " COMPONENT Runtime)
    endif()
endif()

=== Tests/Functional/CMakeLists.txt ===
############################################################################
# Tests/Functional/CMakeLists.txt (called from top-level CMakeLists.txt)
############################################################################

include_directories(${CMAKE_SOURCE_DIR}/Tests/Functional/TestMachinery)

add_subdirectory(Core)
add_subdirectory(Fit)

if(BORNAGAIN_PYTHON)
    add_subdirectory(Python)
endif()

if(BORNAGAIN_GUI)
    add_subdirectory(GUI)
endif()

=== ThirdParty/Fit/CMakeLists.txt ===
add_subdirectory(RootMinimizers)

=== ThirdParty/GUI/CMakeLists.txt ===
add_subdirectory(qt-manhattan-style)
add_subdirectory(qcustomplot)

set(QtAddOn_INCLUDE_DIRS
    ${ManhattanStyle_INCLUDE_DIRS}
    ${qcustomplot_INCLUDE_DIRS}
    PARENT_SCOPE)

set(QtAddOn_LIBRARIES
    ${ManhattanStyle_LIBRARY}
    ${qcustomplot_LIBRARY}
    PARENT_SCOPE)

=== Tests/Functional/Fit/CMakeLists.txt ===
add_subdirectory(Minimizer)

=== debian/changelog ===
bornagain (1.18.0-1) unstable; urgency=medium

  [ Picca Frédéric-Emmanuel ]
  * d/rules: Use --no-parallel to avoid FTBFS.

  [ Sébastien Delafond ]
  * Change install method
  * New upstream version 1.18.0 (Closes: #972762)

 -- Sebastien Delafond <seb@debian.org>  Tue, 08 Dec 2020 09:56:37 +0100

bornagain (1.16.0-1) unstable; urgency=medium

  [ Sébastien Delafond ]
  * New upstream version 1.16.0

 -- Sebastien Delafond <seb@debian.org>  Fri, 17 Apr 2020 16:45:26 +0200

bornagain (1.15.0-1) unstable; urgency=medium

  [ Mika Pflüger ]
  * Initial release (Closes: #844618)

  [ Sébastien Delafond ]
  * d/{control,copyright}

 -- Sebastien Delafond <seb@debian.org>  Fri, 17 Apr 2020 15:18:18 +0200

=== debian/control ===
Source: bornagain
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mika Pflüger <debian@mikapflueger.de>, Sebastien Delafond <seb@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 12),
	       dh-python,
               doxygen-latex <!nodoc>,
               libboost-all-dev,
	       libcerf-dev,
               libeigen3-dev,
               libfftw3-dev,
               libgsl0-dev,
               libqt5designercomponents5,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libtiff5-dev,
               libyaml-cpp-dev,
               python3-dev <!nopython>,
               python3-distutils <!nopython>,
               python3-matplotlib <!nopython>,
               python3-numpy <!nopython>,
               python3-yaml <!nopython>,
               qtbase5-dev,
               qtscript5-dev,
               qttools5-dev,
               swig <!nopython>,
               texlive-fonts-extra <!nodoc>,
               texlive-xetex <!nodoc>
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/bornagain
Vcs-Git: https://salsa.debian.org/science-team/bornagain.git
Homepage: http://bornagainproject.org/

Package: bornagain
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: python3-bornagain
Description: Simulate and fit X-ray and neutron GISAXS -- binary
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org

Package: python3-bornagain
Architecture: any
Depends: python3-matplotlib,
         python3-numpy,
         python3-yaml,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Simulate and fit X-ray and neutron GISAXS -- Python3
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the Python bindings for use in scripts.

Package: bornagain-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: bornagain
Description: Simulate and fit X-ray and neutron GISAXS -- doc
 BornAgain is a software package to simulate and fit small-angle scattering at
 grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
 (GISANS) data. Calculations are carried out in the framework of the distorted
 wave Born approximation (DWBA). BornAgain provides a graphical user interface
 for interactive use as well as a generic Python and C++ framework for modeling
 multilayer samples with smooth or rough interfaces and with various types of
 embedded nanoparticles.
 .
 BornAgain supports:
 .
 Layers:
  * Multilayers without any restrictions on the number of layers
  * Interface roughness correlation
  * Magnetic materials
 .
 Particles:
  * Choice between different shapes of particles (form factors)
  * Particles with inner structures
  * Assemblies of particles
  * Size distribution of the particles (polydispersity)
 .
 Positions of Particles:
  * Decoupled implementations between vertical and planar positions
  * Vertical distributions: particles at specific depth in layers or on top.
  * Planar distributions:
    - fully disordered systems
    - short-range order distribution (paracrystals)
    - two- and one-dimensional lattices
 .
 Input Beam:
  * Polarized or unpolarized neutrons
  * X-ray
  * Divergence of the input beam (wavelength, incident angles) following
    different distributions
  * Possible normalization of the input intensity
 .
 Detector:
  * Off specular scattering
  * Two-dimensional intensity matrix, function of the output angles
 .
 Use of BornAgain:
  * Simulation of GISAXS and GISANS from the generated sample
  * Fitting to reference data (experimental or numerical)
  * Interactions via Python scripts or Graphical User Interface
 .
 If you use BornAgain in your work, please cite
  C. Durniak, M. Ganeva, G. Pospelov, W. Van Herck, J. Wuttke (2015), BornAgain
  — Software for simulating and fitting X-ray and neutron small-angle
  scattering at grazing incidence, version <version you used>,
  http://www.bornagainproject.org
 .
  This package contains the BornAgain documentation.

=== debian/rules ===
#!/usr/bin/make -f
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# deal with profiles
CONFIG_SWITCHES=-DCMAKE_DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH) -DCONFIGURE_MANPAGE=ON -DBORNAGAIN_MPI=ON

ifneq ($(filter nodoc,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_PYTHON_DOCS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_PYTHON_DOCS=ON
endif

ifneq ($(filter nopython,$(DEB_BUILD_PROFILES)),)
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_BINDINGS=OFF
else
	CONFIG_SWITCHES += -DBORNAGAIN_GENERATE_BINDINGS=ON -DPython_ADDITIONAL_VERSIONS="3.9 3.8"
endif

# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk
# CFLAGS+=$(CPPFLAGS)
# CXXFLAGS+=$(CPPFLAGS)

# export CMAKE_OPTIONS := \
#   -DCMAKE_CXX_FLAGS="$(CXXFLAGS)" \
#   -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)" \
#   -DWITH_SHARED_LIB=1 \
#   -DWITH_STATIC_LIB=0 \
#   -DWITH_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig

%:
	dh $@ --with python3 $(CMAKE_OPTIONS)

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES)

# circular import failure, disabling for now
override_dh_auto_test:

# unactive dwz for now... it FTBFS and I do not know how to fic the issue.
# does not work on buster
override_dh_dwz:

=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

http://apps.jcns.fz-juelich.de/src/BornAgain/ BornAgain-([\d\.]+)\.tar\.gz debian uupdate

# Direct Git
# opts="mode=git" http://git.example.com/bornagain.git \
#   refs/tags/v([\d\.]+) debian uupdate

## bornagain 1.19.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 include(commons/PreventInSourceBuilds)
 
 project(BornAgain
-    VERSION 1.18.0
+    VERSION 1.19.0
     DESCRIPTION "BornAgain: simulate and fit scattering at grazing incidence."
     HOMEPAGE_URL https://www.bornagainproject.org
     ) # LANGUAGES CXX)
@@ -34,10 +34,10 @@
 option(BORNAGAIN_PYTHON "Build with python support" ON)
 option(BORNAGAIN_GUI "Build a graphical user interface" ON)
 option(BORNAGAIN_TIFF_SUPPORT "Tiff files read/write support" ON)
+option(BORNAGAIN_NEWREFL "Compile reflectometry GUI prototype" OFF)
 
 # options that are off by default (switch on for additional functionality)
 option(BORNAGAIN_MPI "Build with MPI support" OFF)
-option(SLOWTESTS "CTest also covers slow tests" OFF)
 
 option(CONFIGURE_BINDINGS "Generate python bindings during build (requires swig)" OFF)
 option(CONFIGURE_PYTHON_DOCS "Generate python documentation from the doxygen comments" OFF)
@@ -52,6 +52,7 @@
 option(BORNAGAIN_COVERAGE "Build with test coverage information" OFF)
 option(BORNAGAIN_DEBUG_OPTIMIZATION "Build with debug optimization (gcc only)" OFF)
 option(BORNAGAIN_TIDY "Invokes clang-tidy" OFF)
+option(ALGORITHM_DIAGNOSTIC "Let some algorithms set diagnostic variables" OFF)
 
 if(BORNAGAIN_TIDY AND BORNAGAIN_PYTHON)
     message(FATAL_ERROR "BORNAGAIN_TIDY is incompatible with BORNAGAIN_PYTHON")
@@ -72,9 +73,10 @@
 ## Various CMake settings (include order is of critical importance)
 
 # function definitions
-include(commons/GetFilenameComponent) # overwrite CMake command
-include(BornAgain/MakeLib)
-include(BornAgain/SwigLib)
+include(commons/GetFilenameComponent) # fct get_filename_component (overwrites CMake's built-in)
+include(BornAgain/PythonDocs) # fct GeneratePythonDocs
+include(BornAgain/SwigLib) # fct SwigLib
+include(BornAgain/MakeLib) # fct MakeLib
 
 # main settings
 
@@ -94,6 +96,9 @@
 if(ZERO_TOLERANCE)
     string(APPEND CMAKE_CXX_FLAGS " -Werror -Wfatal-errors")
 endif()
+if(ALGORITHM_DIAGNOSTIC)
+    string(APPEND CMAKE_CXX_FLAGS " -DALGORITHM_DIAGNOSTIC=ON")
+endif()
 
 include(BornAgain/Dependences)
 if(BORNAGAIN_GUI)
@@ -104,17 +109,23 @@
 if(BORNAGAIN_PYTHON)
     include(BornAgain/PythonAPI)
 endif()
-include(BornAgain/PythonDocs)
 
 # debug optimization
 if(BORNAGAIN_DEBUG_OPTIMIZATION)
   include(commons/DebugOptimization)
 endif()
 
+## Fit
+add_subdirectory(Fit/3rdParty)
+add_subdirectory(Fit)
+add_subdirectory(Fit/Test/Unit)
+add_subdirectory(Fit/Test/Minimizer)
+
+
 ## recurse into the given subdirectories
 
-# BornAgain components are build as separate shared libraries
-set(CoreComponents "Base;Fit;Param;Sample;Device;Core")
+# BornAgain components are built as separate shared libraries
+set(CoreComponents "Base;Param;Sample;Device;Core")
 set(AllComponents "${CoreComponents};GUI")
 
 # code analysis
@@ -126,15 +137,18 @@
 
 # third-party code
 add_subdirectory(ThirdParty/common)
-add_subdirectory(ThirdParty/Fit)
 add_subdirectory(ThirdParty/Core)
 if(BORNAGAIN_GUI)
-    add_subdirectory(ThirdParty/GUI)
+    add_subdirectory(ThirdParty/GUI/qcustomplot)
 endif()
 
 # from here on our own code, occasionally scrutinized by clang-tidy
 if(BORNAGAIN_TIDY)
     set(CMAKE_CXX_CLANG_TIDY "clang-tidy") # has effect only if compiler is clang; uses .clang-tidy
+endif()
+
+if(BORNAGAIN_NEWREFL)
+    add_subdirectory(mvvm)
 endif()
 
 # core components
@@ -146,16 +160,20 @@
 endif()
 
 # core tests
-add_subdirectory(Tests/UnitTests/Fit)
 add_subdirectory(Tests/UnitTests/Core)
 add_subdirectory(Tests/UnitTests/Numeric)
 add_subdirectory(Tests/Performance/Core)
+add_subdirectory(Tests/Examples)
 
 # GUI
 if(BORNAGAIN_GUI)
     add_subdirectory(GUI)
     add_subdirectory(Tests/UnitTests/GUI)
     add_subdirectory(Tests/Performance/GUI)
+endif()
+if(BORNAGAIN_NEWREFL)
+    add_subdirectory(gui2)
+    add_subdirectory(Tests/UnitTests/gui2)
 endif()
 
 # TODO: split Core / GUI

=== Core/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainCore
############################################################################

set(name Core)
set(lib BornAgain${name})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

MakeLib(${name} ${lib} ${CMAKE_CURRENT_BINARY_DIR}/Wrap)

set(${lib}_LIBRARY ${lib} PARENT_SCOPE)

# --- external dependencies ---

target_link_libraries(${lib}
    ${BornAgainSample_LIBRARY}
    ${BornAgainDevice_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT})

target_include_directories(${lib}
    PUBLIC ${CMAKE_SOURCE_DIR}
    ${tspectrum_INCLUDE_DIR}
    ${Cerf_INCLUDE_DIR}
    ${CMAKE_SOURCE_DIR}/ThirdParty/Core/ # TEMPORARY
    )
target_link_libraries(${lib}
    ${tspectrum_LIBRARY} ${Cerf_LIBRARIES})

if(BORNAGAIN_MPI)
    add_definitions(-DBORNAGAIN_MPI)
    include_directories(${MPI_INCLUDE_PATH})
    target_link_libraries(${lib} ${MPI_LIBRARIES})
endif()

=== Device/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainDevice
############################################################################

set(name Device)
set(lib BornAgain${name})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

MakeLib(${name} ${lib} ${CMAKE_CURRENT_BINARY_DIR}/Wrap)

set(${lib}_LIBRARY ${lib} PARENT_SCOPE)

# --- external dependencies ---

target_link_libraries(${lib}
    ${BornAgainSample_LIBRARY} # TODO get rid of this dependence
    ${BornAgainParam_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT})
target_include_directories(${lib}
    PUBLIC ${CMAKE_SOURCE_DIR}
    )

target_include_directories(${lib}
    PUBLIC ${CMAKE_SOURCE_DIR}
    ${tspectrum_INCLUDE_DIR}
    )
target_link_libraries(${lib}
    ${tspectrum_LIBRARY}
    )

if(BORNAGAIN_TIFF_SUPPORT)
    target_compile_definitions(${lib} PUBLIC -DBORNAGAIN_TIFF_SUPPORT)
    target_include_directories(${lib} PUBLIC ${TIFF_INCLUDE_DIR})
    target_link_libraries(${lib} ${TIFF_LIBRARIES})
endif()

=== GUI/CMakeLists.txt ===
--- 
+++ 
@@ -5,11 +5,13 @@
 message(STATUS "Configuring BornAgain GUI")
 
 set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTOUIC ON)
 
 add_subdirectory(ba3d)
 add_subdirectory(coregui)
 add_subdirectory(main)
 
+# Transmit variables for use in tests
 set(BornAgainGUI_INCLUDE_DIRS ${BornAgainGUI_INCLUDE_DIRS} PARENT_SCOPE)
 set(BornAgainGUI_LIBRARY ${BornAgainGUI_LIBRARY} PARENT_SCOPE)

=== Param/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainParam
############################################################################

set(name Param)
set(lib BornAgain${name})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

MakeLib(${name} ${lib} ${CMAKE_CURRENT_BINARY_DIR}/Wrap)

set(${lib}_LIBRARY ${lib} PARENT_SCOPE)

# --- external dependencies ---

target_link_libraries(${lib}
    ${BornAgainBase_LIBRARY}
    ${BornAgainFit_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT})
target_include_directories(${lib}
    PUBLIC ${CMAKE_SOURCE_DIR}
    )

=== Sample/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainSample
############################################################################

set(name Sample)
set(lib BornAgain${name})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- make the library ---

MakeLib(${name} ${lib} ${CMAKE_CURRENT_BINARY_DIR}/Wrap)

set(${lib}_LIBRARY ${lib} PARENT_SCOPE)

# --- external dependencies ---

target_link_libraries(${lib}
    ${BornAgainParam_LIBRARY}
    ${CMAKE_THREAD_LIBS_INIT})
target_include_directories(${lib}
    PUBLIC ${CMAKE_SOURCE_DIR}
    )

=== cmake/CMakeLists.txt ===
if(APPLE)
    set(ld_library_variable DYLD_LIBRARY_PATH)
else()
    set(ld_library_variable LD_LIBRARY_PATH)
endif()

# this script is a trick to print the message at the end of installation
if(NOT WIN32 AND NOT BORNAGAIN_APPLE_BUNDLE AND NOT BUILD_DEBIAN)
set(after_install_text "
Installation done. Please read below.
-------------------------------------------------------------------------------
To use BornAgain, add the directory ${CMAKE_INSTALL_PREFIX}/${destination_lib}
to your ${ld_library_variable} and PYTHONPATH.
You can do it by running the command 'source ${CMAKE_INSTALL_PREFIX}/${destination_bin}/thisbornagain.sh'
Just add this command into your .bashrc or .bash_profile file.
-------------------------------------------------------------------------------
")

install(CODE "MESSAGE(\"${after_install_text}\")")

endif()

# to show files in Qt creator
FILE(GLOB_RECURSE ScriptFiles "configurables/*.*")
add_custom_target(scripts SOURCES ${ScriptFiles})

=== gui2/CMakeLists.txt ===
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/modules)

include(configuration)

set(library_name dareflcore)

add_library(${library_name} SHARED "")

# -- Generate header for export --

set(export_filename ${DAREFL_AUTOGEN_DIR}/darefl_export.h)
generate_export_header(${library_name} EXPORT_FILE_NAME ${export_filename})

add_subdirectory(dataloader)
add_subdirectory(importdataview)
add_subdirectory(layereditor)
add_subdirectory(mainwindow)
add_subdirectory(materialeditor)
add_subdirectory(model)
add_subdirectory(quicksimeditor)
add_subdirectory(resources)
add_subdirectory(settingsview)
add_subdirectory(sldeditor)
add_subdirectory(welcomeview)

target_link_libraries(${library_name} PUBLIC MVVM::View Qt5::Core Qt5::Gui Qt5::Widgets
    ${BornAgainCore_LIBRARY})
target_include_directories(${library_name} PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}/..>
    $<BUILD_INTERFACE:${DAREFL_AUTOGEN_DIR}>)

set(executable_name bornagain2)
add_executable(${executable_name} main.cpp)
target_link_libraries(${executable_name} PRIVATE dareflcore)

=== mvvm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)
project(qt-mvvm VERSION 0.2.0 LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)

option(MVVM_BUMP_VERSION "Propagate version number" OFF)
option(MVVM_DISCOVER_TESTS "Auto discover tests and add to ctest, otherwise will run at compile time" ON)
option(MVVM_ENABLE_FILESYSTEM "Enable <filesystem> (requires modern compiler), otherwise rely on Qt" ON)
option(MVVM_BUILD_EXAMPLES "Build user examples" ON)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR}/cmake/modules)
include(configuration)

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)

add_subdirectory(model)
add_subdirectory(viewmodel)
add_subdirectory(view)

add_subdirectory(tests)

include(installation)

# Defines new 'clangformat' target. See CodeTools.cmake for details.
# project_clangformat_setup()

=== Doc/Doxygen/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/html)
 add_custom_target(doxy) # this target builds _all_ documentation flavors
 foreach(flavor user long)
-    configure_file(Doxyfile.${flavor}.in
+    configure_file(${flavor}/Doxyfile.in
         ${AUTO_DOX_DIR}/Doxyfile.${flavor} @ONLY)
     add_custom_target(doxy${flavor}
         COMMAND doxygen ${AUTO_DOX_DIR}/Doxyfile.${flavor} )

=== Doc/man/CMakeLists.txt ===
set(AUTO_DIR ${CMAKE_SOURCE_DIR}/auto/Doc/man)
file(MAKE_DIRECTORY ${AUTO_DIR})

add_custom_target(
    man ALL
    DEPENDS ${AUTO_DIR}/bornagain.1
)

add_custom_command(
    OUTPUT ${AUTO_DIR}/bornagain.1
    COMMAND ${POD2MAN} -s 1 -c "BornAgain manual" ${CMAKE_CURRENT_SOURCE_DIR}/bornagain.pod ${AUTO_DIR}/bornagain.1
    DEPENDS bornagain.pod
)

install(FILES ${AUTO_DIR}/bornagain.1 DESTINATION ${CMAKE_INSTALL_PREFIX}/man/man1)

=== GUI/ba3d/CMakeLists.txt ===
set(lib ba3d)

file (GLOB_RECURSE source_files *.cpp)

set(CMAKE_AUTORCC ON)
qt5_add_resources(RC_SHADERS "shaders.qrc")

add_library (${lib} STATIC ${source_files} ${RC_SHADERS})
target_include_directories(${lib} PUBLIC ${CMAKE_SOURCE_DIR})

target_link_libraries (${lib} Qt5::Core Qt5::Widgets Qt5::OpenGL)

set(${lib}_LIBRARY ${lib} PARENT_SCOPE)

=== debian/changelog ===
bornagain (1.19.0-3build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 as default version

 -- Graham Inggs <ginggs@ubuntu.com>  Thu, 13 Jan 2022 19:05:41 +0000

bornagain (1.19.0-3build1) jammy; urgency=medium

  * No-change rebuild against libgsl27

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 17:25:19 +0000

bornagain (1.19.0-3) unstable; urgency=medium

  * Bug fix: "FTBFS: Precomputed.h:29:11: error: ‘size_t’ has not been
    declared", thanks to Lucas Nussbaum (Closes: #997069).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Sun, 21 Nov 2021 13:44:46 +0100

bornagain (1.19.0-2) unstable; urgency=medium

  * Bug fix: "buggy cmake file", thanks to Yangfl (Closes: #987700).
  * Bug fix: "contains ccache prebuilt objects", thanks to Yangfl (Closes:
    #987677).
  * Bug fix: "ftbfs with GCC-11", thanks to Matthias Klose (Closes:
    #983998).

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 27 Sep 2021 21:01:20 +0200

bornagain (1.19.0-1) unstable; urgency=medium

  [Neil Williams]
  * Add Frédéric Picca as Uploader

  [Picca Frédéric-Emmanuel]
  * d/watch: fixed the url.
  * New upstream version 1.19.0
  * d/pathes: refreshed
  * Use secure URI in Homepage field.
  * Update standards version to 4.6.0, no changes needed.
  * Apply multi-arch hints.
    + bornagain-doc: Add Multi-Arch: foreign.

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Mon, 27 Sep 2021 20:09:13 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,18 @@
 Source: bornagain
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Mika Pflüger <debian@mikapflueger.de>, Sebastien Delafond <seb@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders:
+ Mika Pflüger <debian@mikapflueger.de>,
+ Sebastien Delafond <seb@debian.org>,
+ Picca Frédéric-Emmanuel <picca@debian.org>,
 Section: science
 Priority: optional
 Build-Depends: cmake,
                debhelper-compat (= 12),
-	       dh-python,
+               dh-python,
                doxygen-latex <!nodoc>,
                libboost-all-dev,
-	       libcerf-dev,
+               libcerf-dev,
                libeigen3-dev,
                libfftw3-dev,
                libgsl0-dev,
@@ -28,16 +32,16 @@
                swig <!nopython>,
                texlive-fonts-extra <!nodoc>,
                texlive-xetex <!nodoc>
-Standards-Version: 4.3.0
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/science-team/bornagain
 Vcs-Git: https://salsa.debian.org/science-team/bornagain.git
-Homepage: http://bornagainproject.org/
+Homepage: https://bornagainproject.org/
 
 Package: bornagain
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: python3-bornagain
-Description: Simulate and fit X-ray and neutron GISAXS -- binary
+Description: Simulate and fit X-ray and neutron GISAS -- binary
  BornAgain is a software package to simulate and fit small-angle scattering at
  grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
  (GISANS) data. Calculations are carried out in the framework of the distorted
@@ -97,7 +101,7 @@
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Description: Simulate and fit X-ray and neutron GISAXS -- Python3
+Description: Simulate and fit X-ray and neutron GISAS -- Python3
  BornAgain is a software package to simulate and fit small-angle scattering at
  grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
  (GISANS) data. Calculations are carried out in the framework of the distorted
@@ -156,7 +160,8 @@
 Section: doc
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: bornagain
-Description: Simulate and fit X-ray and neutron GISAXS -- doc
+Multi-Arch: foreign
+Description: Simulate and fit X-ray and neutron GISAS -- doc
  BornAgain is a software package to simulate and fit small-angle scattering at
  grazing incidence. It supports analysis of both X-ray (GISAXS) and neutron
  (GISANS) data. Calculations are carried out in the framework of the distorted

=== debian/rules ===
--- 
+++ 
@@ -31,7 +31,7 @@
 #   -DWITH_PKGCONFIG_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
 
 %:
-	dh $@ --with python3 $(CMAKE_OPTIONS)
+	dh $@ --with python3 --no-parallel $(CMAKE_OPTIONS)
 
 override_dh_auto_configure:
 	dh_auto_configure -- $(CMAKE_OPTIONS) $(CONFIG_SWITCHES)

=== debian/watch ===
version=4
 https://bornagainproject.org/ext/files/master/ BornAgain-([\d\.]+)\.tar\.gz debian uupdate
